## tightgatevnc-clientonly 4.7.2~aatgv1

=== CMakeLists.txt ===
#
# Setup
#

cmake_minimum_required(VERSION 2.8.11)

# Internal cmake modules
set(CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/cmake/Modules)

include(CheckIncludeFiles)
include(CheckFunctionExists)
include(CheckLibraryExists)
include(CheckTypeSize)
include(CheckCSourceCompiles)
include(CheckCXXSourceCompiles)
include(CheckCSourceRuns)

include(CMakeMacroLibtoolFile)

project(tigervnc)
set(VERSION 4.7.2)

# The RC version must always be four comma-separated numbers
set(RCVERSION 4,7,2)

# Installation paths
include(GNUInstallDirs)
set(CMAKE_INSTALL_UNITDIR "lib/systemd/system" CACHE PATH "systemd unit files (lib/systemd/system)")
if(IS_ABSOLUTE "${CMAKE_INSTALL_UNITDIR}")
  set(CMAKE_INSTALL_FULL_UNITDIR "${CMAKE_INSTALL_UNITDIR}")
else()
  set(CMAKE_INSTALL_FULL_UNITDIR "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_UNITDIR}")
endif()

option(INSTALL_SYSTEMD_UNITS "Install TigerVNC systemd units" ON)

if(MSVC)
  message(FATAL_ERROR "TigerVNC cannot be built with Visual Studio.  Please use MinGW")
endif()

if(NOT BUILD_TIMESTAMP)
  STRING(TIMESTAMP BUILD_TIMESTAMP "%Y-%m-%d %H:%M" UTC)
endif()

# Default to optimised builds instead of debug ones. Our code has no bugs ;)
# (CMake makes it fairly easy to toggle this back to Debug if needed)
if(NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE Release)
endif()

message(STATUS "CMAKE_BUILD_TYPE = ${CMAKE_BUILD_TYPE}")

message(STATUS "VERSION = ${VERSION}")
message(STATUS "BUILD_TIMESTAMP = ${BUILD_TIMESTAMP}")
add_definitions(-DBUILD_TIMESTAMP="${BUILD_TIMESTAMP}")

# We want to keep our asserts even in release builds so remove NDEBUG
set(CMAKE_C_FLAGS_RELEASE "${CMAKE_C_FLAGS_RELEASE} -UNDEBUG")
set(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} -UNDEBUG")
set(CMAKE_C_FLAGS_RELWITHDEBINFO "${CMAKE_C_FLAGS_RELWITHDEBINFO} -UNDEBUG")
set(CMAKE_CXX_FLAGS_RELWITHDEBINFO "${CMAKE_CXX_FLAGS_RELWITHDEBINFO} -UNDEBUG")
set(CMAKE_C_FLAGS_MINSIZEREL "${CMAKE_C_FLAGS_MINSIZEREL} -UNDEBUG")
set(CMAKE_CXX_FLAGS_MINSIZEREL "${CMAKE_CXX_FLAGS_MINSIZEREL} -UNDEBUG")

# Make sure we get a sane C version
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -std=gnu99")

# Tell the compiler to be stringent
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall -Wformat=2")
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -Wformat=2")
# Make sure we catch these issues whilst developing
IF(CMAKE_BUILD_TYPE MATCHES Debug)
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Werror -Werror=vla")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Werror -Werror=vla")
ENDIF()

option(ENABLE_ASAN "Enable address sanitizer support" OFF)
if(ENABLE_ASAN AND NOT WIN32 AND NOT APPLE)
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fsanitize=address")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fsanitize=address")
endif()

option(ENABLE_TSAN "Enable thread sanitizer support" OFF)
if(ENABLE_TSAN AND NOT WIN32 AND NOT APPLE AND CMAKE_SIZEOF_VOID_P MATCHES 8)
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fsanitize=thread")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fsanitize=thread")
endif()

#if(NOT DEFINED BUILD_WINVNC)
#  set(BUILD_WINVNC 1)
#endif()

# Minimum version is Windows 7
if(WIN32)
  add_definitions(-D_WIN32_WINNT=0x0601)
endif()

# Legacy macros (macOS 10.12 and older) conflict with our code
if(APPLE)
  add_definitions(-D__ASSERT_MACROS_DEFINE_VERSIONS_WITHOUT_UNDERSCORES=0)
endif()

if(CMAKE_SIZEOF_VOID_P MATCHES 8)
  message(STATUS "64-bit build")
else()
  message(STATUS "32-bit build")
endif()

# Versions of CMake before 2.8.7 do not properly support resource compilation
# with MinGW.  Boo!
if(MINGW AND "${CMAKE_VERSION}" VERSION_LESS "2.8.7")
  if(NOT DEFINED RC)
    set(CMAKE_RC_COMPILER_INIT windres)
  else()
    set(CMAKE_RC_COMPILER_INIT ${RC})
  endif()
  enable_language(RC)
  message(STATUS "Resource compiler: ${CMAKE_RC_COMPILER}")
  set(CMAKE_RC_COMPILE_OBJECT
    "<CMAKE_RC_COMPILER> <FLAGS> <DEFINES> -o <OBJECT> --output-format=coff <SOURCE>")
endif()

# MinGW64 has header support but no library support for IActiveDesktop, so we
# need to check for both the header and library and use our own implementation
# in common/os if either doesn't exist.
if(WIN32)
  check_c_source_compiles("#include <windows.h>\n#include <wininet.h>\n#include <shlobj.h>\nint main(int c, char** v) {IActiveDesktop iad; (void)iad; return 0;}" HAVE_ACTIVE_DESKTOP_H)
  check_c_source_compiles("#include <windows.h>\n#include <wininet.h>\n#include <shlobj.h>\nint main(int c, char** v) {GUID i = CLSID_ActiveDesktop; (void)i; return 0;}" HAVE_ACTIVE_DESKTOP_L)
endif()

# X11 stuff. It's in a if() so that we can say REQUIRED
if(UNIX AND NOT APPLE)
  find_package(X11 REQUIRED)
endif()

# Check for zlib
find_package(ZLIB REQUIRED)

# Check for pixman
find_package(Pixman REQUIRED)

# Check for gettext
option(ENABLE_NLS "Enable translation of program messages" ON)
if(ENABLE_NLS)
  # Tools
  find_package(Gettext)

  # Gettext needs iconv
  find_package(Iconv)

  if(ICONV_FOUND)
    # Headers and libraries (copied from licq)
    set(GETTEXT_FOUND FALSE)

    find_path(GETTEXT_INCLUDE_DIR libintl.h)
    if(GETTEXT_INCLUDE_DIR)
      set(CMAKE_REQUIRED_LIBRARIES ${ICONV_LIBRARIES})
      set(CMAKE_REQUIRED_FLAGS -fno-builtin-dgettext)
      check_function_exists(dgettext LIBC_HAS_DGETTEXT)
      if(LIBC_HAS_DGETTEXT)
        set(GETTEXT_FOUND TRUE)
      else()
        find_library(LIBINTL_LIBRARY NAMES intl libintl)
        if(LIBINTL_LIBRARY)
          check_library_exists(${LIBINTL_LIBRARY} "dgettext" "" LIBINTL_HAS_DGETTEXT)
          if(LIBINTL_HAS_DGETTEXT)
            set(GETTEXT_LIBRARIES ${LIBINTL_LIBRARY} ${ICONV_LIBRARIES})
            set(GETTEXT_FOUND TRUE)
          endif()
        endif()
      endif()
      set(CMAKE_REQUIRED_LIBRARIES)
      set(CMAKE_REQUIRED_FLAGS)
    endif()
  endif()

  if(NOT GETTEXT_FOUND OR NOT ICONV_FOUND)
    message(WARNING "Gettext NOT found.  Native Language Support disabled.")
    set(ENABLE_NLS 0)
  endif()
endif()

# Check for libjpeg
find_package(JPEG REQUIRED)

# Warn if it doesn't seem to be the accelerated libjpeg that's found
set(CMAKE_REQUIRED_LIBRARIES ${JPEG_LIBRARIES})
set(CMAKE_REQUIRED_FLAGS -I${JPEG_INCLUDE_DIR})
if (NOT APPLE)
  set(CMAKE_REQUIRED_FLAGS -I/usr/include/glib-2.0 -I/usr/lib/x86_64-linux-gnu/glib-2.0/include)
endif()

set(JPEG_TEST_SOURCE "\n
  #include <stdio.h>\n
  #include <jpeglib.h>\n
  int main(void) {\n
    struct jpeg_compress_struct cinfo;\n
    struct jpeg_error_mgr jerr;\n
    cinfo.err=jpeg_std_error(&jerr);\n
    jpeg_create_compress(&cinfo);\n
    cinfo.input_components = 3;\n
    jpeg_set_defaults(&cinfo);\n
    cinfo.in_color_space = JCS_EXT_RGB;\n
    jpeg_default_colorspace(&cinfo);\n
    return 0;\n
  }")

if(CMAKE_CROSSCOMPILING)
  check_c_source_compiles("${JPEG_TEST_SOURCE}" FOUND_LIBJPEG_TURBO)
else()
  check_c_source_runs("${JPEG_TEST_SOURCE}" FOUND_LIBJPEG_TURBO)
endif()

set(CMAKE_REQUIRED_LIBRARIES)
set(CMAKE_REQUIRED_FLAGS)
set(CMAKE_REQUIRED_DEFINITIONS)

if(NOT FOUND_LIBJPEG_TURBO)
  message(STATUS "WARNING: You are not using libjpeg-turbo. Performance will suffer.")
endif()

if (NOT APPLE)
  include_directories(${JPEG_INCLUDE_DIR} /usr/include/glib-2.0 /usr/lib/x86_64-linux-gnu/glib-2.0/include)
endif()

option(BUILD_JAVA "Build Java version of the TigerVNC Viewer" FALSE)
if(BUILD_JAVA)
  add_subdirectory(java)
endif()

# Check for FLTK
set(FLTK_SKIP_FLUID TRUE)
set(FLTK_SKIP_OPENGL TRUE)
set(FLTK_SKIP_FORMS TRUE)
find_package(FLTK)

if(UNIX AND NOT APPLE)
  # No proper handling for extra X11 libs that FLTK might need...
  if(X11_Xft_FOUND)
    # Xft headers include references to fontconfig, so we need
    # to link to that as well
    find_library(FONTCONFIG_LIB fontconfig)
    set(FLTK_LIBRARIES ${FLTK_LIBRARIES} ${X11_Xft_LIB} ${FONTCONFIG_LIB})
  endif()
  if(X11_Xinerama_FOUND)
    set(FLTK_LIBRARIES ${FLTK_LIBRARIES} ${X11_Xinerama_LIB})
  endif()
  if(X11_Xfixes_FOUND)
    set(FLTK_LIBRARIES ${FLTK_LIBRARIES} ${X11_Xfixes_LIB})
  endif()
  if(X11_Xcursor_FOUND)
    set(FLTK_LIBRARIES ${FLTK_LIBRARIES} ${X11_Xcursor_LIB})
  endif()
  if(X11_Xrender_FOUND)
    set(FLTK_LIBRARIES ${FLTK_LIBRARIES} ${X11_Xrender_LIB})
  endif()
endif()

# Check for GNUTLS library
option(ENABLE_GNUTLS "Enable protocol encryption and advanced authentication" ON)
if(ENABLE_GNUTLS)
  find_package(GnuTLS)
  if (GNUTLS_FOUND)
    include_directories(${GNUTLS_INCLUDE_DIR})
    add_definitions("-DHAVE_GNUTLS")
    add_definitions(${GNUTLS_DEFINITIONS})
  endif()
endif()

# Check for PAM library
if(UNIX AND NOT APPLE)
  check_include_files(security/pam_appl.h HAVE_PAM_H)
  set(CMAKE_REQUIRED_LIBRARIES -lpam)
  check_function_exists(pam_start HAVE_PAM_START)
  set(CMAKE_REQUIRED_LIBRARIES)
  if(HAVE_PAM_H AND HAVE_PAM_START)
    set(PAM_LIBS pam)
  else()
    message(FATAL_ERROR "Could not find PAM development files")
  endif()
endif()

# Check for socket functions
if(WIN32)
  set(CMAKE_EXTRA_INCLUDE_FILES winsock2.h ws2tcpip.h)
  # check_function_exists() cannot handle stdcall, so just define things
  set(HAVE_INET_ATON 1)
  set(HAVE_GETADDRINFO 1)
else()
  check_function_exists(inet_aton HAVE_INET_ATON)
  check_function_exists(getaddrinfo HAVE_GETADDRINFO)
  set(CMAKE_REQUIRED_LIBRARIES)
  set(CMAKE_EXTRA_INCLUDE_FILES sys/socket.h)
endif()
check_function_exists(inet_aton HAVE_INET_ATON)
check_function_exists(getaddrinfo HAVE_GETADDRINFO)
set(CMAKE_EXTRA_INCLUDE_FILES)
set(CMAKE_REQUIRED_LIBRARIES)

check_function_exists(gettid HAVE_GETTID)

# Generate config.h and make sure the source finds it
configure_file(config.h.in config.h)
add_definitions(-DHAVE_CONFIG_H)
include_directories(${CMAKE_BINARY_DIR})

include(cmake/StaticBuild.cmake)

add_subdirectory(common)

if(WIN32)
  add_subdirectory(win)
else()
  # No interest in building x related parts on Apple
  if(NOT APPLE)
    add_subdirectory(unix)
  endif()
endif()

if(ENABLE_NLS)
  add_subdirectory(po)
endif()

option(BUILD_VIEWER "Build TigerVNC viewer" ON)
if(BUILD_VIEWER)
  add_subdirectory(vncviewer)
  add_subdirectory(media)
endif()

add_subdirectory(tests)


add_subdirectory(release)

# uninstall
configure_file("${CMAKE_SOURCE_DIR}/cmake/cmake_uninstall.cmake.in"
  "cmake_uninstall.cmake" IMMEDIATE @ONLY)

add_custom_target(uninstall COMMAND ${CMAKE_COMMAND} -P cmake_uninstall.cmake)

=== debian/changelog ===
tightgatevnc-clientonly (4.7.2~aatgv1) testing; urgency=low

  * git (rebase-20210322-4.7) 81e4b1909eb413f47f0de901709a4904f4afaf86
    Revert 4ba8ca35e19dda35f6a7e4488fe7e34f665cb655 and 385a5725a795dadadd632cae37652d967df631b1
    Hand reverted, because the text-only clipboard checks seem to lead to hanging
    connections and git revert does not work here.
  * git (rebase-20210322-4.7) 5a0f14303fd40041e56f65bb8b8d705663b3ea36
    Version 4.7.2

 -- Amon Ott <ao@m-privacy.de>  Wed, 23 Jul 2025 15:24:00 +0200

tightgatevnc-clientonly (4.7.1~aatgv2) testing; urgency=low

  * git (rebase-20210322-4.7) 7624ffa95e1995f5311777e08af79bb44bf3a144
    Update viewer copyright year to 2025.
  * git (rebase-20210322-4.7) b2145aab60209ac3a7abb441124c933168ecdbe6
    BUG 0007211: Viewer Linux - 4.4.2 - zeigt lauter Extension-Kram
    NativeMessagingApp: Remove 'juaaa' from log line.
  * git (rebase-20210322-4.7) 86ef99c9797b78bc9e9db0452ee631064c7b8bb9
    BUG 0007211: Viewer Linux - 4.4.2 - zeigt lauter Extension-Kram
    NativeMessagingApp: Make a bunch of vlog.info() -> vlog.debug()
  * debian/rules:
    - add to all FLAGS: -D_GLIBCXX_ASSERTIONS -fstack-clash-protection

 -- Amon Ott <ao@m-privacy.de>  Mon, 21 Jul 2025 08:51:00 +0200

tightgatevnc-clientonly (4.7.1~aatgv1) testing; urgency=low

  * git (rebase-20210322-4.7) 916eeeed6ae39ee96b1c99b13d9ea1131f8a3597
    Port upstream git 422444acf3a519b75709fb14c02118b75ecbc898
        Fix overflow; "Timer: gettimeofday is broken"
        The rounding misbehaved when the tv_usec calculation overflows.
        Fixes issue #1782.
  * git (rebase-20210322-4.7) 0b950e1795000564c71017b844dbe6ce6311439c
    Port upstream git 7af69eb4a7a52d6baf4d09f79ccbec76bd1fcee1
        Don't parse empty fence messages
        We need to return here or we'll do an out-of-bounds access on the data
        array.
  * git (rebase-20210322-4.7) 6d7d48846aded894394c7863c504eb79ebd397bb
    Port upstream git 6111c0587aec6ea4700a91a460c7027572ab5011
        Include key code for fake key events
        Let's try to mimic a real event as much as possible to avoid bugs.
  * git (rebase-20210322-4.7) 4abb6d3fd58acfbb29b65f409c433742299c2a22
    Port upstream git 5c108b657890d9f2a92de1060884448448b6e565
        Update processMsg() description
        This method is no longer blocking, so the description needed to be
        adjusted.
  * git (rebase-20210322-4.7) 385a5725a795dadadd632cae37652d967df631b1
    Port upstream git 8a80c906b9f7c08b1c664569a97d327d62c6d8ae
        Only announce clipboard for plain text data
        FLTK has support for both image and plain text clipboard data, we don't.
        This means we only send plain text clipboard from the viewer to the
        server. Some applications can get confused when we announce that
        clipboard is available and later don't send anything. An example of such
        an application is QGIS, in the remote session it froze when an image was
        copied on the client side.
        This fix means we only call announceClipboard() when the clipboard
        contains plain text. That means TigerVNC is now more robust and doesn't
        trigger freezes in buggy applications.
  * git (rebase-20210322-4.7) 4ba8ca35e19dda35f6a7e4488fe7e34f665cb655
    Port upstream git 6f6d9406035d59b6a9f59ff0f38206c0c98a0266
        Clear clipboard state when its not plain text
        Commit 8a80c906b9f7c08b1c664569a97d327d62c6d8ae added a check to prevent
        announcing clipboard when it's not plain text data. When this check
        triggers and we want to ignore the non-plain text clipboard, we should
        reset the state by no longer indicating pending clipboard, and by asking
        the server to clear its clipboard. This ensures we don't end up in a
        state where the server thinks the viewer has useful clipboard data, but
        it doesn't.
  * git (rebase-20210322-4.7) 3150f7b74ada00f257938b317bb8c01d3209c964
    Port upstream git 6c8387018b130eb4ef69ea377e9154ba04f0fd50
        Avoid invalid XFree for XClassHint
        It seems XGetClassHint() doesn't set the pointers to NULL if there is no
        name, so we need to make sure it is cleared beforehand. Otherwise we can
        get an invalid pointer given to XFree().
  * git (rebase-20210322-4.7) 3353d202a055186e891f39bb4b7d8d3b7a25a23b
    Partually port upstream git 892832531627e16e61f6ccc602e1995cf065bba7
    common/network/Socket:
        Always flush sockets on shutdown()
        The system shutdown() function doesn't drop buffered data, so neither
        should we.
        We had one fix in place, but that didn't cover all cases. Move this
        handling to all socket like classes we have.
  * git (rebase-20210322-4.7) a29075d653343d4827df8322e05c2a8c80a47226
    Port upstream git a1da2b6ac56a35bb46e9a32317d894d9595e3dc4
        Fix uncaught clipboard network errors
        All communication with the server needs to be prepared for network
        errors.
  * git (rebase-20210322-4.7) c43ea57f2dcb2d7b5c8da1804f7d89c7035cc09d
    Port upstream git 62d47fc4aab4419dbc2937b4aebdc6ff52671f06
        Avoid conflict with Fl_Window::maximize()
        First step to enable compatibility with FLTK 1.4.
  * git (rebase-20210322-4.7) 96e7b74de77a12b3783b05e9d9405796a17541fb
    Partially port upstream git 655da47027a8f91ec39c1d107406f346900dd694
        Remove superfluous resizeFramebuffer() calls
        These are not needed since the cleanup in 6ea58ba.
  * git (rebase-20210322-4.7) d52ae9ff17b73e0bb58c8cb3baf01a9c8315a0c3
    Port upstream git 9de223d40bd8c8324840fa8ff1e52f55c9d3877b
        Closing auth window is Cancel, not Ok
  * git (rebase-20210322-4.7) 25d19b5e032cfae5c0545f1ca677e0761430515a
    Port upstream git afdbbcc44f5e140f64b0de4cc3eff9be3b5142d4
        Don't enable full screen until MapNotify
        Modern mutter (GNOME's window manager) has an internal race condition
        where changing state early is unreliable. Waiting for the MapNotify


=== debian/control ===
Source: tightgatevnc-clientonly
Section: x11
Priority: optional
Maintainer: m-privacy GmbH (<info@m-privacy.de>)
Build-Depends: debhelper (>= 4.0.0), perl, gcc, g++, sed,
 libgettextpo-dev, cmake, libxft-dev, libcap-dev, libaudit-dev,
 libxinerama-dev, libpng-dev, libfltk1.3-dev,
 libturbojpeg0-dev, libjpeg62-turbo-dev, zlib1g-dev, automake1.9 | automake1.11, autoconf,
 xserver-xorg-dev, xutils, pkg-config, x11proto-bigreqs-dev,
 x11proto-composite-dev, x11proto-core-dev (>= 7.0.26), x11proto-damage-dev,
 x11proto-fixes-dev, x11proto-kb-dev (>= 1.0.1-1), x11proto-xinerama-dev,
 x11proto-randr-dev (>= 1.4.0), x11proto-record-dev, x11proto-render-dev,
 x11proto-resource-dev, x11proto-scrnsaver-dev, x11proto-video-dev,
 x11proto-xcmisc-dev, x11proto-xext-dev (>= 7.2.99.901),
 x11proto-xf86bigfont-dev, x11proto-xf86dga-dev,
 x11proto-xf86vidmode-dev, xtrans-dev (>= 1.3.3), libxau-dev (>= 1:0.1.2-1),
 libxdmcp-dev (>= 1:0.1.3-2), libxfont-dev (>= 2), libfontenc-dev,
 libxkbfile-dev (>= 7.0.0-1), x11proto-xf86dri-dev, libdrm-dev (>> 2.0),
 x11proto-gl-dev (>= 1.4.1-1), libgl1-mesa-dev (>= 7.8.0), libxmuu-dev (>= 1:1.0.2-2),
 libxext-dev (>= 1:1.0.1-2), libx11-dev (>= 1:6.2.1+cvs.20050722-1),
 libxrender-dev (>= 1:0.9.0-1), libxi-dev (>= 1:1.0.1-4), x11proto-dmx-dev,
 dpatch, libdmx-dev, libxpm-dev (>= 1:3.5.3-1), libxaw7-dev (>= 1:1.0.2-4),
 libxt-dev (>> 1:0.99.3+cvs.20051212), libxmu-dev (>= 1:1.0.2-2),
 libxtst-dev (>= 1:1.0.1-5), libxres-dev (>= 1:1.0.2+0.99.1-1),
 libfreetype6-dev, flex, dpatch, gnutls28-nop11-dev | libgnutls28-dev, nasm, libtool,
 x11proto-gl-dev, libpciaccess-dev, libexpat1-dev, cvs,
 libpam0g-dev, autopoint, xutils-dev, x11proto-fonts-dev (>= 2.1.3),
 x11proto-input-dev (>= 2.3), x11proto-dri2-dev, libxxf86vm-dev, libxfixes-dev,
 libsm-dev, libice-dev, libpixman-1-dev, libxdamage-dev, libglu1-mesa-dev,
 libosmesa6-dev, mesa-common-dev, libpthread-stubs0-dev,
 xfonts-utils (>= 7.5), libgcrypt-dev, libgsasl7-dev (>= 1.8.0),
 libgsasl7-dev (<< 1.8.0-3),
 libmprivacy (>= 1.0.55+aatgv1), libtasn1-6-dev, nettle-dev,
 libkrb5support0-static | libkrb5-dev, libkrb5-static-3 | libkrb5-dev, libgssapi-krb5-static-2 | libkrb5-dev,
 libkeyutils-dev, librsvg2-bin, libxcursor-dev, libbz2-dev,
 libc6-dev, libssh-dev, libnacl-dev, libcurl4-gnutls-dev,
 x11proto-present-dev, libb64-dev, fluid, libjemalloc-dev, libmagic-dev, rename,
 libglib2.0-dev, libmount-dev, libunistring-dev, libidn2-dev,
 libopenh264-dev (>= 2.3.1-2), libzstd-dev, libwebp-dev, libbrotli-dev,
 nlohmann-json3-dev, libunwind-dev,
 comerr-dev, libjxl-dev, libmount-dev (<< 2.36.1-8+),
 libarchive-dev, gettext-base, librsbac-dev
Build-Conflicts: libc6 (>= 2.32)
Standards-Version: 3.6.1

Package: tightgateviewer
Section: net
Architecture: any
Provides: vnc-viewer
Replaces: xvnc4viewer, tigervncviewer
Depends: libc6 (>> 2.31), ${shlibs:Depends}
Conflicts: tightgateviewer-internal
Recommends: gstreamer1.0-tools, daemon, v4l-utils, ffmpeg
Suggests: tightgatevnc-common
Description: TightGate-Pro VNC client
 VNC stands for Virtual Network Computing. It is, in essence, a remote
 display system which allows you to view a computing `desktop' environment
 not only on the machine where it is running, but from anywhere on the
 Internet and from a wide variety of machine architectures.
 .
 It is implemented in a client/server model. This package provides a vncclient
 for X, with this you can connect to a vncserver somewhere in the network
 and display its content in a window. There are vncserver available for X
 and for Win95/NT.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# GNU copyright 1997 to 1999 by Joey Hess.
#
# Modified to make a template file for a multi-binary package with separated
# build-arch and build-indep targets  by Bill Allombert 2001

#DEB_HOST_MULTIARCH =

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1

# This has to be exported to make some magic below work.
export DH_OPTIONS

#export http_proxy=http://192.168.8.254:3130
export no_proxy="localhost"
export ftp_proxy=http://192.168.8.254:3138

# These are used for cross-compiling and for saving the configure script
# from having to guess our platform (since we know it already)
DEB_HOST_GNU_TYPE   ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
#DEB_HOST_GNU_TYPE   = i686-linux-gnu
DEB_BUILD_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)
#DEB_BUILD_GNU_TYPE  = $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)


# original
#export CFLAGS = -Wall -Werror -g -O3 -Wl,-z,lazy -Wno-deprecated -Wno-deprecated-declarations -fstack-protector-all -mtune=corei7 -flto=8 -ffat-lto-objects -fPIE -Wno-stringop-overflow -Wno-alloc-size-larger-than -Wno-error=stringop-truncation -Wno-error=odr -Wno-error=return-local-addr -Wno-error=stringop-overread
#export SERVERCFLAGS = -Wall -g -O3 -Wl,-z,lazy -Wno-deprecated -Wno-deprecated-declarations -fstack-protector-all -mtune=corei7 -flto=8 -ffat-lto-objects -fPIE -Wno-stringop-overflow -Wno-alloc-size-larger-than -Wno-error=stringop-truncation -Wno-error=odr -Wno-error=return-local-addr -Wno-error=stringop-overread
#export CXXFLAGS = -Wall -Werror -g -O3 -Wl,-z,lazy -Wno-deprecated -Wno-deprecated-declarations -fstack-protector-all -std=gnu++0x -mtune=corei7 -flto=8 -ffat-lto-objects -fPIE -Wno-stringop-overflow -Wno-alloc-size-larger-than -Wno-error=stringop-truncation -Wno-error=odr -Wno-error=return-local-addr -Wno-error=stringop-overread
#export LDFLAGS = -Wl,--as-needed -Wl,--allow-multiple-definition -flto=8 -ffat-lto-objects -fPIE -Wno-stringop-overflow -Wno-alloc-size-larger-than -Wno-error=stringop-truncation -Wno-error=odr -Wno-error=stringop-overread

# GCC 8 / Buster
#export CFLAGS = -lzstd -Wall -Werror -g -O3 -Wl,-z,lazy -Wno-deprecated -Wno-deprecated-declarations -fstack-protector-all -march=x86-64-v2 -mtune=generic -fno-lto -ffat-lto-objects -fPIE -Wno-stringop-overflow -Wno-error=stringop-truncation -Wno-error=odr -Wno-error=return-local-addr
#export SERVERCFLAGS = -lzstd -Wall -g -O3 -Wl,-z,lazy -Wno-deprecated -Wno-deprecated-declarations -fstack-protector-all -march=x86-64-v2 -mtune=generic -fno-lto -ffat-lto-objects -fPIE -Wno-stringop-overflow -Wno-error=stringop-truncation -Wno-error=odr -Wno-error=return-local-addr
#export CXXFLAGS = -lzstd -Wall -Werror -g -O3 -Wl,-z,lazy -Wno-deprecated -Wno-deprecated-declarations -fstack-protector-all -std=gnu++0x -march=x86-64-v2 -mtune=generic -fno-lto -ffat-lto-objects -fPIE -Wno-stringop-overflow -Wno-error=stringop-truncation -Wno-error=odr -Wno-error=return-local-addr
#export LDFLAGS = -lzstd -Wl,--as-needed -Wl,--allow-multiple-definition -march=x86-64-v2 -mtune=generic -fno-lto -ffat-lto-objects -fPIE -Wno-stringop-overflow -Wno-error=stringop-truncation -Wno-error=odr
# Buster with lto
export CFLAGS = -lzstd -Wall -Werror -g -O3 -Wl,-z,lazy -D_GLIBCXX_ASSERTIONS -fstack-clash-protection -Wno-deprecated -Wno-deprecated-declarations -fstack-protector-all -march=x86-64-v2 -mtune=generic -flto -ffat-lto-objects -fPIE -Wno-stringop-overflow -Wno-error=stringop-truncation -Wno-error=odr -Wno-error=return-local-addr
export SERVERCFLAGS = -lzstd -Wall -g -O3 -Wl,-z,lazy -D_GLIBCXX_ASSERTIONS -fstack-clash-protection -Wno-deprecated -Wno-deprecated-declarations -fstack-protector-all -march=x86-64-v2 -mtune=generic -flto -ffat-lto-objects -fPIE -Wno-stringop-overflow -Wno-error=stringop-truncation -Wno-error=odr -Wno-error=return-local-addr
export CXXFLAGS = -lzstd -Wall -Werror -g -O3 -Wl,-z,lazy -D_GLIBCXX_ASSERTIONS -fstack-clash-protection -Wno-deprecated -Wno-deprecated-declarations -fstack-protector-all -std=gnu++0x -march=x86-64-v2 -mtune=generic -flto -ffat-lto-objects -fPIE -Wno-stringop-overflow -Wno-error=stringop-truncation -Wno-error=odr -Wno-error=return-local-addr
export LDFLAGS = -lzstd -lunistring -Wl,--as-needed -Wl,--allow-multiple-definition -march=x86-64-v2 -mtune=generic -flto -ffat-lto-objects -fPIE -D_GLIBCXX_ASSERTIONS -fstack-clash-protection -Wno-stringop-overflow -Wno-error=stringop-truncation -Wno-error=odr

#export CFLAGS = -nolibc -static-pie -lc -lgcc -lunwind -llzma -Wall -Werror -g -O3 -Wl,-z,lazy -Wno-deprecated -Wno-deprecated-declarations -fstack-protector-all -mtune=corei7 -flto=8 -ffat-lto-objects -fPIE -Wno-stringop-overflow -Wno-alloc-size-larger-than -Wno-error=stringop-truncation -Wno-error=odr -Wno-error=return-local-addr -Wno-error=stringop-overread
#export SERVERCFLAGS = -nolibc -static-pie -lc -lgcc -lunwind -llzma -Wall -g -O3 -Wl,-z,lazy -Wno-deprecated -Wno-deprecated-declarations -fstack-protector-all -mtune=corei7 -flto=8 -ffat-lto-objects -fPIE -Wno-stringop-overflow -Wno-alloc-size-larger-than -Wno-error=stringop-truncation -Wno-error=odr -Wno-error=return-local-addr -Wno-error=stringop-overread
#export CXXFLAGS = -nolibc -static-pie -lc -lgcc -lunwind -llzma -Wall -Werror -g -O3 -Wl,-z,lazy -Wno-deprecated -Wno-deprecated-declarations -fstack-protector-all -std=gnu++0x -mtune=corei7 -flto=8 -ffat-lto-objects -fPIE -Wno-stringop-overflow -Wno-alloc-size-larger-than -Wno-error=stringop-truncation -Wno-error=odr -Wno-error=return-local-addr -Wno-error=stringop-overread
#export LDFLAGS = -nolibc -static-pie -lc -lgcc -lunwind -llzma -Wl,--as-needed -Wl,--allow-multiple-definition -flto=8 -ffat-lto-objects -fPIE -Wno-stringop-overflow -Wno-alloc-size-larger-than -Wno-error=stringop-truncation -Wno-error=odr -Wno-error=stringop-overread
#export CFLAGS = -nodefaultlibs -static-pie -lc -lm -lgcc -lgcc_eh -lunwind -llzma -ldl -Wall -Werror -g -O3 -Wl,-z,lazy -Wno-deprecated -Wno-deprecated-declarations -fstack-protector-all -mtune=corei7 -flto=8 -ffat-lto-objects -fPIE -Wno-stringop-overflow -Wno-alloc-size-larger-than -Wno-error=stringop-truncation -Wno-error=odr -Wno-error=return-local-addr -Wno-error=stringop-overread
#export SERVERCFLAGS = -nodefaultlibs -static-pie -lc -lm -lgcc -lgcc_eh -lunwind -llzma -ldl -Wall -g -O3 -Wl,-z,lazy -Wno-deprecated -Wno-deprecated-declarations -fstack-protector-all -mtune=corei7 -flto=8 -ffat-lto-objects -fPIE -Wno-stringop-overflow -Wno-alloc-size-larger-than -Wno-error=stringop-truncation -Wno-error=odr -Wno-error=return-local-addr -Wno-error=stringop-overread
#export CXXFLAGS = -nodefaultlibs -static-pie -lc -lm -lgcc -lgcc_eh -lunwind -llzma -ldl -Wall -Werror -g -O3 -Wl,-z,lazy -Wno-deprecated -Wno-deprecated-declarations -fstack-protector-all -std=gnu++0x -mtune=corei7 -flto=8 -ffat-lto-objects -fPIE -Wno-stringop-overflow -Wno-alloc-size-larger-than -Wno-error=stringop-truncation -Wno-error=odr -Wno-error=return-local-addr -Wno-error=stringop-overread
#export LDFLAGS = -nodefaultlibs -static-pie -lc -lm -lgcc -lgcc_eh -lunwind -llzma -ldl -Wl,--as-needed -Wl,--allow-multiple-definition -flto=8 -ffat-lto-objects -fPIE -Wno-stringop-overflow -Wno-alloc-size-larger-than -Wno-error=stringop-truncation -Wno-error=odr -Wno-error=stringop-overread

#LDFLAGS += -Wl,-Bstatic -lheif -lx265 -lde265 -laom -lopenh264 -Wl,-Bdynamic -Wno-error=return-local-addr
CMAKE_BUILD_TYPE = Debug
INCLDIR = /usr/include/

libsearch = $(shell find /lib /usr/lib -iname $(1) -print -quit)

TURBOJPEG = $(call libsearch,libturbojpeg.a)
GNUTLS = $(call libsearch,libgnutls.a)
NETTLE = $(call libsearch,libnettle.a)
TASN1 = $(call libsearch,libtasn1.a)
HOGWEED = $(call libsearch,libhogweed.a)
CRYPT = $(call libsearch,libcrypt.a)
GSASL = $(call libsearch,libgsasl.a)
IDN = $(call libsearch,libidn.a)
NTLM = $(call libsearch,libntlm.a)
Z = $(call libsearch,libz.a)
